/*
 * ++Copyright++ 1983, 1993
 * -
 * Copyright (c) 1983, 1993
 *    The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * -
 * Portions Copyright (c) 1993 by Digital Equipment Corporation.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies, and that
 * the name of Digital Equipment Corporation not be used in advertising or
 * publicity pertaining to distribution of the document or software without
 * specific, written prior permission.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND DIGITAL EQUIPMENT CORP. DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS.   IN NO EVENT SHALL DIGITAL EQUIPMENT
 * CORPORATION BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 * -
 * --Copyright--
 */

/*
 *      @(#)inet.h      8.1 (Berkeley) 6/2/93
 *      $Id: inet.h,v 8.6 1996/08/08 06:54:29 vixie Exp $
 */

#ifndef _ARPA_INET_H_
#define _ARPA_INET_H_

#ifdef TCPV40HDRS
#error error: arpa\inet.h is for TCP/IP toolkit 5.0 or later releases only
#else
/* External definitions for functions in inet(3) */

#include <sys/param.h>
#include <sys/types.h>
#include <sys/cdefs.h>

__BEGIN_DECLS
unsigned long _System inet_addr __TCPPROTO((const char *));
int _System inet_aton __TCPPROTO((const char *, struct in_addr *));
unsigned long _System inet_lnaof __TCPPROTO((struct in_addr));
struct in_addr _System inet_makeaddr __TCPPROTO((u_long , u_long));
char * _System inet_neta __TCPPROTO((u_long, char *, size_t));
unsigned long _System inet_netof __TCPPROTO((struct in_addr));
unsigned long _System inet_network __TCPPROTO((const char *));
char * _System inet_net_ntop __TCPPROTO((int, const void *, int, char *, size_t));
int _System inet_net_pton __TCPPROTO((int, const char *, void *, size_t));
char * _System inet_ntoa __TCPPROTO((struct in_addr));
int _System inet_pton __TCPPROTO((int af, const char *src, void *dst));
const char * _System inet_ntop __TCPPROTO((int af, const void *src, char *dst, size_t s));
u_int _System inet_nsap_addr __TCPPROTO((const char *, u_char *, int maxlen));
char * _System inet_nsap_ntoa __TCPPROTO((int, const u_char *, char *ascii));
__END_DECLS

#endif /* TCPV40HDRS */
#endif /* !_ARPA_INET_H_ */
