/*----------------------------------------------------------------*/
/*                   802.2 Command Codes                          */
/*----------------------------------------------------------------*/
     #define   LLC_DIR_INTERRUPT                            0x0000
     #define   LLC_DIR_OPEN_ADAPTER                         0x0003
     #define   LLC_DIR_CLOSE_ADAPTER                        0x0004
     #define   LLC_DIR_SET_GROUP_ADDRESS                    0x0006
     #define   LLC_DIR_SET_FUNCTIONAL_ADDRESS               0x0007
     #define   LLC_DIR_READ_LOG                             0x0008
     #define   LLC_TRANSMIT_DIR_FRAME                       0x000A
     #define   LLC_TRANSMIT_I_FRAME                         0x000B
     #define   LLC_TRANSMIT_UI_FRAME                        0x000D
     #define   LLC_TRANSMIT_XID_CMD                         0x000E
     #define   LLC_TRANSMIT_XID_RESP_FINAL                  0x000F
     #define   LLC_TRANSMIT_XID_RESP_NOT_FINAL              0x0010
     #define   LLC_TRANSMIT_TEST_CMD                        0x0011
     #define   LLC_DLC_RESET                                0x0014
     #define   LLC_DLC_OPEN_SAP                             0x0015
     #define   LLC_DLC_CLOSE_SAP                            0x0016
     #define   LLC_DLC_REALLOCATE_STATIONS                  0x0017
     #define   LLC_DLC_OPEN_STATION                         0x0019
     #define   LLC_DLC_CLOSE_STATION                        0x001A
     #define   LLC_DLC_CONNECT_STATION                      0x001B
     #define   LLC_DLC_MODIFY                               0x001C
     #define   LLC_DLC_FLOW_CONTROL                         0x001D
     #define   LLC_DLC_STATISTICS                           0x001E
     #define   LLC_DIR_INITIALIZE                           0x0020
     #define   LLC_DIR_STATUS                               0x0021
     #define   LLC_DIR_TIMER_SET                            0x0022
     #define   LLC_DIR_TIMER_CANCEL                         0x0023
     #define   LLC_BUFFER_GET                               0x0026
     #define   LLC_BUFFER_FREE                              0x0027
     #define   LLC_RECEIVE                                  0x0028
     #define   LLC_RECEIVE_CANCEL                           0x0029
     #define   LLC_RECEIVE_MODIFY                           0x002A
     #define   LLC_DIR_TIMER_CANCEL_GROUP                   0x002C
     #define   LLC_DIR_SET_EXCEPTION_FLAGS                  0x002D
     #define   LLC_READ                                     0x0031
     #define   LLC_READ_CANCEL                              0x0032
     #define   LLC_DLC_SET_THRESHOLD                        0x0033
     #define   LLC_DIR_CLOSE_DIRECT                         0x0034
     #define   LLC_DIR_OPEN_DIRECT                          0x0035
     #define   LLC_PURGE_RESOURCES                          0x0036


/*----------------------------------------------------------------*/
/*                   802.2 Return Codes                           */
/*----------------------------------------------------------------*/
     #define   LLC_CCB_ACCEPTED                             0x0000
     #define   LLC_INVALID_CCB_PTR                          0x0001
     #define   LLC_INVALID_CCB                              0x0002
     #define   LLC_INVALID_CCB_CHAIN                        0x0003
     #define   LLC_ADAPTER_CLOSED_RC_ERROR                  0x0004
     #define   LLC_UNACCEPTABLE_RC                          0x0005
     #define   LLC_INVALID_COMMAND_PTR                      0x0006

     #define   LLC_COMMAND_ACCEPTED                         0x0000
     #define   LLC_INVALID_COMMAND                          0x0001
     #define   LLC_DUPLICATE_COMMAND                        0x0002
     #define   LLC_ADAPTER_OPEN                             0x0003
     #define   LLC_ADAPTER_CLOSED                           0x0004
     #define   LLC_REQUIRED_PARAMETER                       0x0005
     #define   LLC_INVALID_OPTION                           0x0006
     #define   LLC_CMND_CAN                                 0x0007
     #define   LLC_INVALID_PRIORITY                         0x0008
     #define   LLC_CMND_CAN_BY_USER                         0x000A
     #define   LLC_CMND_CAN_ADAPTER_CLOSED                  0x000B
     #define   LLC_COMMAND_CMPL_NOT_OPENED                  0x000C
     #define   LLC_TIMER_ERROR                              0x0011
     #define   LLC_INVALID_LOG_ID                           0x0013
     #define   LLC_INADEQUATE_LOG                           0x0015
     #define   LLC_BAD_BUFFER_SIZE                          0x0016
     #define   LLC_BAD_SAP_BUFFER_SIZE                      0x0018
     #define   LLC_INADEQUATE_BUFFERS                       0x0019
     #define   LLC_USER_AREA_TOO_LARGE                      0x001A
     #define   LLC_INVALID_PARM_OFFSET                      0x001B
     #define   LLC_INVALID_POINTER                          0x001C
     #define   LLC_INVALID_ADAPTER                          0x001D
     #define   LLC_NO_BUFFERS_AVAILABLE                     0x0020
     #define   LLC_INADEQUATE_BUFFER_AREA                   0x0021
     #define   LLC_TRANSMIT_ERROR                           0x0022
     #define   LLC_DATA_REMOVAL_ERROR                       0x0023
     #define   LLC_INVALID_MAC_FRAME                        0x0024
     #define   LLC_MAX_CMND_EXCEEDED                        0x0025
     #define   LLC_LINK_NOT_XMIT_I_FRAME                    0x0027
     #define   LLC_INVALID_FRAME_LENGTH                     0x0028
     #define   LLC_INADEQUATE_RCV_BUFFERS                   0x0030
     #define   LLC_INVALID_NODE_ADDRESS                     0x0032
     #define   LLC_INVALID_RCV_BUF_LEN                      0x0033
     #define   LLC_INVALID_XMIT_BUF_LEN                     0x0034
     #define   LLC_INVALID_STATION_ID                       0x0040
     #define   LLC_PROTOCOL_ERROR                           0x0041
     #define   LLC_PARM_EXCEEDED_MAX                        0x0042
     #define   LLC_INVALID_SAP_VALUE                        0x0043
     #define   LLC_INVALID_ROUTING_INFO                     0x0044
     #define   LLC_NONEXISTENT_GRP_SAP                      0x0045
     #define   LLC_INADEQUATE_LINK_STN                      0x0046
     #define   LLC_SAP_NOT_CLOSED                           0x0047
     #define   LLC_GRP_SAP_NOT_CLOSED                       0x0048
     #define   LLC_GRP_SAP_MAX                              0x0049
     #define   LLC_SEQUENCE_ERROR                           0x004A
     #define   LLC_STATION_CLOSED_NOACK                     0x004B
     #define   LLC_SEQUENCE_ERROR_CMND_OUT                  0x004C
     #define   LLC_CONNECTION_FAILED                        0x004D
     #define   LLC_MEMBER_SAP_NOT_FOUND                     0x004E
     #define   LLC_INVALID_REMOTE_ADDR                      0x004F
     #define   LLC_INVALID_CCB_POINTER                      0x0050
     #define   LLC_INVALID_APPL_ID                          0x0052
     #define   LLC_INVALID_APPL_KEYCODE                     0x0053
     #define   LLC_INVALID_SYS_KEYCODE                      0x0054
     #define   LLC_BUFFER_LEN_TOO_SMALL                     0x0055
     #define   LLC_SYS_PROC_NOT_INSTALLED                   0x0056
     #define   LLC_INADEQUATE_STN_AVAIALBLE                 0x0057
     #define   LLC_INVALID_CCB_PARAMETER1                   0x0058
     #define   LLC_INADEQUATE_ELEMENTS                      0x0059
     #define   LLC_INITIALIZATION_FAILURE                   0x005A
     #define   LLC_CCB_CHAIN_ERROR                          0x005B
     #define   LLC_DIR_STN_NOT_ASSIGNED                     0x005C
     #define   LLC_DD_NOT_INSTALLED                         0x005D
     #define   LLC_ADAPTER_NOT_INSTALLED                    0x005E
     #define   LLC_CHAIN_ADAPTER_ERROR                      0x005F
     #define   LLC_ADAPTER_INITIALIZING                     0x0060
     #define   LLC_MAX_USER_EXCEEDED                        0x0061
     #define   LLC_SYSTEM_ACTION                            0x0062
     #define   LLC_DIR_STN_NOT_AVAILABLE                    0x0063
     #define   LLC_INVALID_DDNAME                           0x0064
     #define   LLC_NO_GDT_SELECTORS                         0x0065
     #define   LLC_CCB_PURGED                               0x0067
     #define   LLC_INVALID_INTERFACE_APPLID                 0x0068
     #define   LLC_SEGMENT_LOCK_UNSUCCESSFUL                0x0069
     #define   LLC_COMMAND_IN_PROGRESS                      0x00FF
