
/*
 * This file was generated by the SOM Compiler.
 * FileName: somperrd.h.
 * Generated using:
 *     SOM Precompiler somipc: 2.29.1.17
 *     SOM Emitter emith: 2.47
 */

#ifndef SOM_Module_somperrd_SOMPError_defined
#define SOM_Module_somperrd_SOMPError_defined 1
#include <som.h>

/*
 * Start of bindings for IDL types
 */

#ifndef SOMClass
    #define SOMClass SOMObject
#endif /* SOMClass */
#define ex_SOMPError_sompException "::SOMPError::sompException"
typedef
struct SOMPError_sompException {
long  primary;
/*
 *  See below for primary error values
 */

long  secondary;
/*
 *  primary=1, see errno.h,  primary=2, see below...
 */

} SOMPError_sompException;
#define SOMPError_SOMPERROR_SYSTEM_ERROR 1 /* 1 */
/*
 *  Errors reported by the system. See errno.h for secondary value
 */

#define SOMPError_SOMPERROR_FRAMEWORK_ERROR 2 /* 2 */
/*
 *  Framework specific error. See below for secondary value
 */

#define SOMPError_SR_BASE 10 /* 10 */
/*
 *  Base for secondary error values
 */

#define SOMPError_SOMPERROR_OBJ_ALREADY_REGISTERED 10 /* 10+0 */
/*
 *    Attempt to register an object that was already registered.
 *    This is an internal error and should not be user visible.
 */

#define SOMPError_SOMPERROR_COULD_NOT_FIND_DIR 11 /* 10+1 */
/*
 *    The system ID assigner attempted to use the path specified in
 *    the environment variable SOMP_PERSIST to find the file containing
 *    the last assigned ID, and the path did not exist.  Check the value
 *    of SOMP_PERSIST and make sure it points to a valid pathname.
 */

#define SOMPError_SOMPERROR_IOGROUP_EMPTY 12 /* 10+2 */
/*
 *    One of the IO Group Managers was asked to write an empty IOGroup.
 *    This is an internal error and should not be user visible.
 */

#define SOMPError_SOMPERROR_COULD_NOT_RESTORE_OBJ 13 /* 10+3 */
/*
 *    A request was made to restore an object.  The ID indicated
 *    a valid file, but the requested object was not in the file.
 */

#define SOMPError_SOMPERROR_OBJ_IS_NOT_PERSISTENT 14 /* 10+4 */
/*
 *    Attempted to store an object that is not derived from PersistentObject.
 *    Only objects derived from PersistentObject can be stored.
 */

#define SOMPError_SOMPERROR_IOGROUP_NEWOBJ 15 /* 10+5 */
/*
 *    Attempted to restore object, but the appropriate class object
 *    could not be found. Users with SOMPERROR_IOGROUP_NEWOBJ errors
 *    should put their object in a dynamically loadable file or use
 *    their "<className>NewClass" function to create their class object
 *    before attempt to restore objects.
 * 
 *    If the objects are already in a DLL, ensure that:
 *    - The SOMInitModule function for the DLL executes the
 *      <className>NewClass function for the class which can not
 *      be restored.
 *    - On OS/2, ensure that the SOMInitModule entry point uses
 *      the "system" linkage convention. (see samples)
 *    - The class definiation in question has the "dllname" modifier.
 *      For example, if your dll was named foo.dll you should have
 *      dllname="foo.dll"; in your .idl file.
 *    - That you have updated the interface repository for your class.
 *      Assuming foo.idl, you can run "sc -sir -u foo.idl" to update
 *      the IR.
 *    - Ensure environment variable SOMIR points to the correct IR
 *      file.
 * 
 *    When all else fails, explicitly call the <className>NewClass
 *    function of your class before attempting to restore it.
 * 
 */

#define SOMPError_SOMPERROR_IOGROUP_NOTREAD 16 /* 10+6 */
/*
 *    Attempted to read an object whose I/O Group has never been
 *    read.  This is an internal error, and should not be user
 *    visible.
 */

#define SOMPError_SOMPERROR_OBJ_IS_NOT_INITIALIZED 17 /* 10+7 */
/*
 *    Attempted to store an object which was not properly initialized.
 *    Code needs to initialize a persistent object with a PersistentID
 *    before saving.
 * 
 *    Ensure that you have done one of :
 *    - sompInitGivenId
 *    - sompInitNextAvail
 *    - sompInitNearObject
 *    on the persistent object.
 * 
 */

#define SOMPError_SOMPERROR_PFW_INIT_FAILED 18 /* 10+8 */
/*
 *    Failure to instantiate either the PersistentStorageMgr or
 *    the NameSpaceMgr.  This is an internal error, and should not
 *    be user visible.
 */

#define SOMPError_SOMPERROR_ED_INVALID_DATA_TYPE 19 /* 10+9 */
/*
 *    Default Encoder/Decoder attempted to read in some data, but
 *    could not recognize the data type.  This could indicate a
 *    corrupted data file or an internal error.
 */

#define SOMPError_SOMPERROR_BAD_OBJECT_ID_STRING 20 /* 10+10 */
/*
 *    You have attempted to initialize a persistent ID with a
 *    string that is not of the appropriate syntax.
 * 
 *    The correct form of a persistent ID is:
 * 
 *      <IOGroupMgrClassName>:<IOGroupName>:<GroupKey>
 * 
 *     where:
 * 
 *       <IOGroupMgrClassName> is the class name of an IO Group Manager
 *       class. The framework supplies two: SOMPAscii and SOMPBinary
 * 
 *       <IOGroupName> is a name understandable to the IOGroupMgrClass.
 *       SOMPAscii and SOMPBinary expect this name to be a file name.
 * 
 *       <GroupKey> is a key number
 * 
 *    If this error occurs during restore, either the ID you have
 *    passed to the Persistent Storage Mgr is incorrect, or possibly
 *    the ID of an object embedded in the object you are attempting
 *    to restore is incorrect. The string ID read from storage may
 *    have been corrupted on disk.
 */

#define SOMPError_SOMPERROR_INVALID_OBJECT_TYPE 21 /* 10+11 */
/*
 *    One of the media interfaces attempted to determine the type
 *    of an object and couldn't.  This could indicate a corrupted
 *    data file or an internal error.
 */

#define SOMPError_SOMPERROR_ENC_DEC_NOT_FOUND 22 /* 10+12 */
/*
 *    The class object of the encoder/decoder you are attempting to
 *    use can not be found.  To determine what class the framework
 *    is attempting to find you can invoke the method
 * 
 *       sompGetEncoderDecoderName
 * 
 *    on the objects of the class you are attempting to save/restore.
 * 
 *    This error is typically the result of specifying a user written
 *    encoder/decoder class (via either sompSetEncoderDecoderName
 *    or sompSetClassLevelEncoderDecoderName) without first ensuring
 *    that its class object exists. Execute either the "NewClass"
 *    function of the encoder/decoder class or ensure that it is
 *    installed correctly in a DLL. (see SOMPERROR_IOGROUP_NEWOBJ)
 * 
 *    If the the encoder/decoder class name is SOMPAttrEncodeDecoder,
 *    then there is a problem with the framework.
 * 
 */

#define SOMPError_SOMPERROR_IOGROUP_DOES_NOT_EXIST 23 /* 10+13 */
/*
 *    PersistentStorageMgr was trying to read or delete an object, but couldn't
 *    find the IOGroup. For SOMPAscii and SOMPBinary, this means that
 *    the file could not be found.
 * 
 *    This error is the result of sompGroupExists method returning FALSE.
 * 
 */

#define SOMPError_SOMPERROR_OBJECT_NOT_FOUND 24 /* 10+14 */
/*
 *    The object could not be restored or deleted because it could
 *    not be found.
 * 
 *    Ensure that the SOMP_PERSIST environment variable is set
 *    the same as when you stored the object.
 * 
 *    If the file appears to be there but you still can't restore,
 *    perhaps the upper/lower case difference in the name of the file.
 *    The framework is case sensitive.
 */

#define SOMPError_SOMPERROR_INTERFACE_NOT_FOUND 25 /* 10+15 */
/*
 *    One of the IOGroupManagers was attempting to copy a group
 *    and could not find the appropriate MediaInterface.  This is an
 *    internal error and should not be user visible.
 */

#define SOMPError_SOMPERROR_NOT_STORING_OBJECTS 26 /* 10+16 */
/*
 *    sompAddObjectToWriteSet has been called but since the
 *    PersistentStorageMgr is not currently storing objects there
 *    is no write set.
 * 
 *    The sompAddObjectToWriteSet method is intended to be used
 *    by encoder/decoder objects which are run during a save/restore.
 */

#define SOMPError_SOMPERROR_POINTER_NOT_REGISTERED 27 /* 10+17 */
/*
 *    Undocumented method was invoked.  This is an internal error,
 *    and should not be user visible.
 */

#define SOMPError_SOMPERROR_MEDIA_FORMAT_ERROR 28 /* 10+18 */
/*
 *    Attempt was made to read a file with a particular IOGroupMgr,
 *    but the file was incompatible with the requested IOGroupMgr.
 *    Make sure the IOGroupMgr specified in the PersistentID is
 *    compatible with the IOGroupMgr that wrote the file.
 * 
 *    This error may also occur if you attempt to restore an object
 *    from a file produced by an aborted store. If the store attempt
 *    failed, the file may have been left in an invalid format.
 * 
 */

#define SOMPError_SOMPERROR_BAD_IOGROUP_MANAGER 29 /* 10+19 */
/*
 *    Attempted to restore an object with a nonexistent IOGroupMgr.
 *    Check the name of the IOGroupMgr in the Persistent ID.
 * 
 *    The IOGroupMgr class name is the first part of a peristent ID.
 *    The class object of the IOGroupMgr must exist prior to invoking
 *    store/restore requests to it. Ensure that you have either called
 *    the <className>NewClass procedure of your IOGroupMgr class or
 *    have properly installed your class into a dynamically loadable
 *    library. (see SOMPERROR_IOGROUP_NEWOBJ)
 */

#define SOMPError_SOMPERROR_NOT_RESTORING_OBJECTS 30 /* 10+20 */
/*
 *    sompAddIdToReadSet has been called but since the
 *    PersistentStorageMgr is not currently restoring objects there
 *    is no read set.
 * 
 *    The sompAddIdToReadSet method is intended to be used by encoder/decoder
 *    objects which are run during a save/restore.
 */

#define SOMPError_SOMPERROR_ED_AGGREGATE_TYPE_CHG 31 /* 10+21 */
/*
 *    An object has been redefined in a way that one of its aggregate
 *    data types is no longer compatible with its stored data.
 *    Typically this means that either
 *    - A new member has been added to a structure.
 *    - A sequence's type has been changed, i.e. what had been a sequence
 *      of reals is now a sequence of strings.
 *    - An array's type has been changed, i.e. what had been an array
 *      of reals is now an array of strings.
 */

#define SOMPError_SOMPERROR_ED_ATTR_NOT_DEFINED 32 /* 10+22 */
/*
 *    An object has been redefined such that one of its attributes
 *    is no longer valid.
 * 
 *    During the restore of an object, data for an nonexistent attribute
 *    was found. The restore has been aborted.
 */

#define SOMPError_SOMPERROR_ED_TC_RESTORE_FAILED 33 /* 10+23 */
/*
 *    An attempt to read a type code failed.  This could indicate
 *    corrupted data file or an internal error.
 */

#define SOMPError_SOMPERROR_ED_TYPECHG 34 /* 10+24 */
/*
 *    The definition for an attribute has changed its type.
 * 
 *    During the restore of an object, the data type of an attribute
 *    has been found to be different than stored data type.
 *    The restore has been aborted.
 */

#define SOMPError_SOMPERROR_ED_TYPE_SIZE_CHG 35 /* 10+25 */
/*
 *    The definition for a sequence has changed such that the amount
 *    of data stored in the sequence exceeds the new maximum.
 */

#define SOMPError_SOMPERROR_ED_UNSUPPORTED_TYPE 36 /* 10+26 */
/*
 *    Attempted to store a non supported type code.  The type of the
 *    data was not a recognized CORBA data type.
 */

#define SOMPError_SOMPERROR_ED_CLASS_NOT_DEFINED 37 /* 10+27 */
/*
 *    An attempt was made to read an object that is not registered
 *    in the inteface repository.
 */

#define SOMPError_SOMPERROR_DUPLICATE_OBJECT_ID 38 /* 10+28 */
/*
 *    Attempted to initialize an object with the same ID as another
 *    object already initialized.
 */

#define SOMPError_SOMPERROR_SOMDISPATCH_FAILED 39 /* 10+29 */
/*
 *    In the process of storing or restoring an object, the dispatch
 *    of the _get or _set method of an attribute failed. This is
 *    usually a problem with the SOMInitModule.
 */

#define SOMPError_SOMPERROR_TEST_ERROR 109 /* 10+99 */
/*
 *  for testing purposes
 */

#define SOMPError_SOMPINFO_END_OF_ATTRIBUTES 44 /* 10+34 */
/*
 *  defedidl - internal use
 */

#define SOMPError_SOMPERROR_MAX 4096 /* 4096 */
/*
 *    Error numbers 1 through 4096 are reserved by the framework.
 *    Error numbers above 4096 are available for use by extensions of the
 *    framework.
 */


#ifndef SOM_DONT_USE_SHORT_NAMES
#ifndef SOMTGD_ex_sompException
    #ifdef ex_sompException
        #undef ex_sompException
        #define SOMTGD_ex_sompException 1
    #else
        #define ex_sompException ex_SOMPError_sompException
    #endif /* ex_sompException */
#endif /* SOMTGD_ex_sompException */
#ifndef SOMTGD_sompException
    #ifdef sompException
        #undef sompException
        #define SOMTGD_sompException 1
    #else
        #define sompException SOMPError_sompException
    #endif /* sompException */
#endif /* SOMTGD_sompException */
#ifndef SOMTGD_SOMPERROR_SYSTEM_ERROR
    #ifdef SOMPERROR_SYSTEM_ERROR
        #undef SOMPERROR_SYSTEM_ERROR
        #define SOMTGD_SOMPERROR_SYSTEM_ERROR 1
    #else
        #define SOMPERROR_SYSTEM_ERROR SOMPError_SOMPERROR_SYSTEM_ERROR
    #endif /* SOMPERROR_SYSTEM_ERROR */
#endif /* SOMTGD_SOMPERROR_SYSTEM_ERROR */
#ifndef SOMTGD_SOMPERROR_FRAMEWORK_ERROR
    #ifdef SOMPERROR_FRAMEWORK_ERROR
        #undef SOMPERROR_FRAMEWORK_ERROR
        #define SOMTGD_SOMPERROR_FRAMEWORK_ERROR 1
    #else
        #define SOMPERROR_FRAMEWORK_ERROR SOMPError_SOMPERROR_FRAMEWORK_ERROR
    #endif /* SOMPERROR_FRAMEWORK_ERROR */
#endif /* SOMTGD_SOMPERROR_FRAMEWORK_ERROR */
#ifndef SOMTGD_SR_BASE
    #ifdef SR_BASE
        #undef SR_BASE
        #define SOMTGD_SR_BASE 1
    #else
        #define SR_BASE SOMPError_SR_BASE
    #endif /* SR_BASE */
#endif /* SOMTGD_SR_BASE */
#ifndef SOMTGD_SOMPERROR_OBJ_ALREADY_REGISTERED
    #ifdef SOMPERROR_OBJ_ALREADY_REGISTERED
        #undef SOMPERROR_OBJ_ALREADY_REGISTERED
        #define SOMTGD_SOMPERROR_OBJ_ALREADY_REGISTERED 1
    #else
        #define SOMPERROR_OBJ_ALREADY_REGISTERED SOMPError_SOMPERROR_OBJ_ALREADY_REGISTERED
    #endif /* SOMPERROR_OBJ_ALREADY_REGISTERED */
#endif /* SOMTGD_SOMPERROR_OBJ_ALREADY_REGISTERED */
#ifndef SOMTGD_SOMPERROR_COULD_NOT_FIND_DIR
    #ifdef SOMPERROR_COULD_NOT_FIND_DIR
        #undef SOMPERROR_COULD_NOT_FIND_DIR
        #define SOMTGD_SOMPERROR_COULD_NOT_FIND_DIR 1
    #else
        #define SOMPERROR_COULD_NOT_FIND_DIR SOMPError_SOMPERROR_COULD_NOT_FIND_DIR
    #endif /* SOMPERROR_COULD_NOT_FIND_DIR */
#endif /* SOMTGD_SOMPERROR_COULD_NOT_FIND_DIR */
#ifndef SOMTGD_SOMPERROR_IOGROUP_EMPTY
    #ifdef SOMPERROR_IOGROUP_EMPTY
        #undef SOMPERROR_IOGROUP_EMPTY
        #define SOMTGD_SOMPERROR_IOGROUP_EMPTY 1
    #else
        #define SOMPERROR_IOGROUP_EMPTY SOMPError_SOMPERROR_IOGROUP_EMPTY
    #endif /* SOMPERROR_IOGROUP_EMPTY */
#endif /* SOMTGD_SOMPERROR_IOGROUP_EMPTY */
#ifndef SOMTGD_SOMPERROR_COULD_NOT_RESTORE_OBJ
    #ifdef SOMPERROR_COULD_NOT_RESTORE_OBJ
        #undef SOMPERROR_COULD_NOT_RESTORE_OBJ
        #define SOMTGD_SOMPERROR_COULD_NOT_RESTORE_OBJ 1
    #else
        #define SOMPERROR_COULD_NOT_RESTORE_OBJ SOMPError_SOMPERROR_COULD_NOT_RESTORE_OBJ
    #endif /* SOMPERROR_COULD_NOT_RESTORE_OBJ */
#endif /* SOMTGD_SOMPERROR_COULD_NOT_RESTORE_OBJ */
#ifndef SOMTGD_SOMPERROR_OBJ_IS_NOT_PERSISTENT
    #ifdef SOMPERROR_OBJ_IS_NOT_PERSISTENT
        #undef SOMPERROR_OBJ_IS_NOT_PERSISTENT
        #define SOMTGD_SOMPERROR_OBJ_IS_NOT_PERSISTENT 1
    #else
        #define SOMPERROR_OBJ_IS_NOT_PERSISTENT SOMPError_SOMPERROR_OBJ_IS_NOT_PERSISTENT
    #endif /* SOMPERROR_OBJ_IS_NOT_PERSISTENT */
#endif /* SOMTGD_SOMPERROR_OBJ_IS_NOT_PERSISTENT */
#ifndef SOMTGD_SOMPERROR_IOGROUP_NEWOBJ
    #ifdef SOMPERROR_IOGROUP_NEWOBJ
        #undef SOMPERROR_IOGROUP_NEWOBJ
        #define SOMTGD_SOMPERROR_IOGROUP_NEWOBJ 1
    #else
        #define SOMPERROR_IOGROUP_NEWOBJ SOMPError_SOMPERROR_IOGROUP_NEWOBJ
    #endif /* SOMPERROR_IOGROUP_NEWOBJ */
#endif /* SOMTGD_SOMPERROR_IOGROUP_NEWOBJ */
#ifndef SOMTGD_SOMPERROR_IOGROUP_NOTREAD
    #ifdef SOMPERROR_IOGROUP_NOTREAD
        #undef SOMPERROR_IOGROUP_NOTREAD
        #define SOMTGD_SOMPERROR_IOGROUP_NOTREAD 1
    #else
        #define SOMPERROR_IOGROUP_NOTREAD SOMPError_SOMPERROR_IOGROUP_NOTREAD
    #endif /* SOMPERROR_IOGROUP_NOTREAD */
#endif /* SOMTGD_SOMPERROR_IOGROUP_NOTREAD */
#ifndef SOMTGD_SOMPERROR_OBJ_IS_NOT_INITIALIZED
    #ifdef SOMPERROR_OBJ_IS_NOT_INITIALIZED
        #undef SOMPERROR_OBJ_IS_NOT_INITIALIZED
        #define SOMTGD_SOMPERROR_OBJ_IS_NOT_INITIALIZED 1
    #else
        #define SOMPERROR_OBJ_IS_NOT_INITIALIZED SOMPError_SOMPERROR_OBJ_IS_NOT_INITIALIZED
    #endif /* SOMPERROR_OBJ_IS_NOT_INITIALIZED */
#endif /* SOMTGD_SOMPERROR_OBJ_IS_NOT_INITIALIZED */
#ifndef SOMTGD_SOMPERROR_PFW_INIT_FAILED
    #ifdef SOMPERROR_PFW_INIT_FAILED
        #undef SOMPERROR_PFW_INIT_FAILED
        #define SOMTGD_SOMPERROR_PFW_INIT_FAILED 1
    #else
        #define SOMPERROR_PFW_INIT_FAILED SOMPError_SOMPERROR_PFW_INIT_FAILED
    #endif /* SOMPERROR_PFW_INIT_FAILED */
#endif /* SOMTGD_SOMPERROR_PFW_INIT_FAILED */
#ifndef SOMTGD_SOMPERROR_ED_INVALID_DATA_TYPE
    #ifdef SOMPERROR_ED_INVALID_DATA_TYPE
        #undef SOMPERROR_ED_INVALID_DATA_TYPE
        #define SOMTGD_SOMPERROR_ED_INVALID_DATA_TYPE 1
    #else
        #define SOMPERROR_ED_INVALID_DATA_TYPE SOMPError_SOMPERROR_ED_INVALID_DATA_TYPE
    #endif /* SOMPERROR_ED_INVALID_DATA_TYPE */
#endif /* SOMTGD_SOMPERROR_ED_INVALID_DATA_TYPE */
#ifndef SOMTGD_SOMPERROR_BAD_OBJECT_ID_STRING
    #ifdef SOMPERROR_BAD_OBJECT_ID_STRING
        #undef SOMPERROR_BAD_OBJECT_ID_STRING
        #define SOMTGD_SOMPERROR_BAD_OBJECT_ID_STRING 1
    #else
        #define SOMPERROR_BAD_OBJECT_ID_STRING SOMPError_SOMPERROR_BAD_OBJECT_ID_STRING
    #endif /* SOMPERROR_BAD_OBJECT_ID_STRING */
#endif /* SOMTGD_SOMPERROR_BAD_OBJECT_ID_STRING */
#ifndef SOMTGD_SOMPERROR_INVALID_OBJECT_TYPE
    #ifdef SOMPERROR_INVALID_OBJECT_TYPE
        #undef SOMPERROR_INVALID_OBJECT_TYPE
        #define SOMTGD_SOMPERROR_INVALID_OBJECT_TYPE 1
    #else
        #define SOMPERROR_INVALID_OBJECT_TYPE SOMPError_SOMPERROR_INVALID_OBJECT_TYPE
    #endif /* SOMPERROR_INVALID_OBJECT_TYPE */
#endif /* SOMTGD_SOMPERROR_INVALID_OBJECT_TYPE */
#ifndef SOMTGD_SOMPERROR_ENC_DEC_NOT_FOUND
    #ifdef SOMPERROR_ENC_DEC_NOT_FOUND
        #undef SOMPERROR_ENC_DEC_NOT_FOUND
        #define SOMTGD_SOMPERROR_ENC_DEC_NOT_FOUND 1
    #else
        #define SOMPERROR_ENC_DEC_NOT_FOUND SOMPError_SOMPERROR_ENC_DEC_NOT_FOUND
    #endif /* SOMPERROR_ENC_DEC_NOT_FOUND */
#endif /* SOMTGD_SOMPERROR_ENC_DEC_NOT_FOUND */
#ifndef SOMTGD_SOMPERROR_IOGROUP_DOES_NOT_EXIST
    #ifdef SOMPERROR_IOGROUP_DOES_NOT_EXIST
        #undef SOMPERROR_IOGROUP_DOES_NOT_EXIST
        #define SOMTGD_SOMPERROR_IOGROUP_DOES_NOT_EXIST 1
    #else
        #define SOMPERROR_IOGROUP_DOES_NOT_EXIST SOMPError_SOMPERROR_IOGROUP_DOES_NOT_EXIST
    #endif /* SOMPERROR_IOGROUP_DOES_NOT_EXIST */
#endif /* SOMTGD_SOMPERROR_IOGROUP_DOES_NOT_EXIST */
#ifndef SOMTGD_SOMPERROR_OBJECT_NOT_FOUND
    #ifdef SOMPERROR_OBJECT_NOT_FOUND
        #undef SOMPERROR_OBJECT_NOT_FOUND
        #define SOMTGD_SOMPERROR_OBJECT_NOT_FOUND 1
    #else
        #define SOMPERROR_OBJECT_NOT_FOUND SOMPError_SOMPERROR_OBJECT_NOT_FOUND
    #endif /* SOMPERROR_OBJECT_NOT_FOUND */
#endif /* SOMTGD_SOMPERROR_OBJECT_NOT_FOUND */
#ifndef SOMTGD_SOMPERROR_INTERFACE_NOT_FOUND
    #ifdef SOMPERROR_INTERFACE_NOT_FOUND
        #undef SOMPERROR_INTERFACE_NOT_FOUND
        #define SOMTGD_SOMPERROR_INTERFACE_NOT_FOUND 1
    #else
        #define SOMPERROR_INTERFACE_NOT_FOUND SOMPError_SOMPERROR_INTERFACE_NOT_FOUND
    #endif /* SOMPERROR_INTERFACE_NOT_FOUND */
#endif /* SOMTGD_SOMPERROR_INTERFACE_NOT_FOUND */
#ifndef SOMTGD_SOMPERROR_NOT_STORING_OBJECTS
    #ifdef SOMPERROR_NOT_STORING_OBJECTS
        #undef SOMPERROR_NOT_STORING_OBJECTS
        #define SOMTGD_SOMPERROR_NOT_STORING_OBJECTS 1
    #else
        #define SOMPERROR_NOT_STORING_OBJECTS SOMPError_SOMPERROR_NOT_STORING_OBJECTS
    #endif /* SOMPERROR_NOT_STORING_OBJECTS */
#endif /* SOMTGD_SOMPERROR_NOT_STORING_OBJECTS */
#ifndef SOMTGD_SOMPERROR_POINTER_NOT_REGISTERED
    #ifdef SOMPERROR_POINTER_NOT_REGISTERED
        #undef SOMPERROR_POINTER_NOT_REGISTERED
        #define SOMTGD_SOMPERROR_POINTER_NOT_REGISTERED 1
    #else
        #define SOMPERROR_POINTER_NOT_REGISTERED SOMPError_SOMPERROR_POINTER_NOT_REGISTERED
    #endif /* SOMPERROR_POINTER_NOT_REGISTERED */
#endif /* SOMTGD_SOMPERROR_POINTER_NOT_REGISTERED */
#ifndef SOMTGD_SOMPERROR_MEDIA_FORMAT_ERROR
    #ifdef SOMPERROR_MEDIA_FORMAT_ERROR
        #undef SOMPERROR_MEDIA_FORMAT_ERROR
        #define SOMTGD_SOMPERROR_MEDIA_FORMAT_ERROR 1
    #else
        #define SOMPERROR_MEDIA_FORMAT_ERROR SOMPError_SOMPERROR_MEDIA_FORMAT_ERROR
    #endif /* SOMPERROR_MEDIA_FORMAT_ERROR */
#endif /* SOMTGD_SOMPERROR_MEDIA_FORMAT_ERROR */
#ifndef SOMTGD_SOMPERROR_BAD_IOGROUP_MANAGER
    #ifdef SOMPERROR_BAD_IOGROUP_MANAGER
        #undef SOMPERROR_BAD_IOGROUP_MANAGER
        #define SOMTGD_SOMPERROR_BAD_IOGROUP_MANAGER 1
    #else
        #define SOMPERROR_BAD_IOGROUP_MANAGER SOMPError_SOMPERROR_BAD_IOGROUP_MANAGER
    #endif /* SOMPERROR_BAD_IOGROUP_MANAGER */
#endif /* SOMTGD_SOMPERROR_BAD_IOGROUP_MANAGER */
#ifndef SOMTGD_SOMPERROR_NOT_RESTORING_OBJECTS
    #ifdef SOMPERROR_NOT_RESTORING_OBJECTS
        #undef SOMPERROR_NOT_RESTORING_OBJECTS
        #define SOMTGD_SOMPERROR_NOT_RESTORING_OBJECTS 1
    #else
        #define SOMPERROR_NOT_RESTORING_OBJECTS SOMPError_SOMPERROR_NOT_RESTORING_OBJECTS
    #endif /* SOMPERROR_NOT_RESTORING_OBJECTS */
#endif /* SOMTGD_SOMPERROR_NOT_RESTORING_OBJECTS */
#ifndef SOMTGD_SOMPERROR_ED_AGGREGATE_TYPE_CHG
    #ifdef SOMPERROR_ED_AGGREGATE_TYPE_CHG
        #undef SOMPERROR_ED_AGGREGATE_TYPE_CHG
        #define SOMTGD_SOMPERROR_ED_AGGREGATE_TYPE_CHG 1
    #else
        #define SOMPERROR_ED_AGGREGATE_TYPE_CHG SOMPError_SOMPERROR_ED_AGGREGATE_TYPE_CHG
    #endif /* SOMPERROR_ED_AGGREGATE_TYPE_CHG */
#endif /* SOMTGD_SOMPERROR_ED_AGGREGATE_TYPE_CHG */
#ifndef SOMTGD_SOMPERROR_ED_ATTR_NOT_DEFINED
    #ifdef SOMPERROR_ED_ATTR_NOT_DEFINED
        #undef SOMPERROR_ED_ATTR_NOT_DEFINED
        #define SOMTGD_SOMPERROR_ED_ATTR_NOT_DEFINED 1
    #else
        #define SOMPERROR_ED_ATTR_NOT_DEFINED SOMPError_SOMPERROR_ED_ATTR_NOT_DEFINED
    #endif /* SOMPERROR_ED_ATTR_NOT_DEFINED */
#endif /* SOMTGD_SOMPERROR_ED_ATTR_NOT_DEFINED */
#ifndef SOMTGD_SOMPERROR_ED_TC_RESTORE_FAILED
    #ifdef SOMPERROR_ED_TC_RESTORE_FAILED
        #undef SOMPERROR_ED_TC_RESTORE_FAILED
        #define SOMTGD_SOMPERROR_ED_TC_RESTORE_FAILED 1
    #else
        #define SOMPERROR_ED_TC_RESTORE_FAILED SOMPError_SOMPERROR_ED_TC_RESTORE_FAILED
    #endif /* SOMPERROR_ED_TC_RESTORE_FAILED */
#endif /* SOMTGD_SOMPERROR_ED_TC_RESTORE_FAILED */
#ifndef SOMTGD_SOMPERROR_ED_TYPECHG
    #ifdef SOMPERROR_ED_TYPECHG
        #undef SOMPERROR_ED_TYPECHG
        #define SOMTGD_SOMPERROR_ED_TYPECHG 1
    #else
        #define SOMPERROR_ED_TYPECHG SOMPError_SOMPERROR_ED_TYPECHG
    #endif /* SOMPERROR_ED_TYPECHG */
#endif /* SOMTGD_SOMPERROR_ED_TYPECHG */
#ifndef SOMTGD_SOMPERROR_ED_TYPE_SIZE_CHG
    #ifdef SOMPERROR_ED_TYPE_SIZE_CHG
        #undef SOMPERROR_ED_TYPE_SIZE_CHG
        #define SOMTGD_SOMPERROR_ED_TYPE_SIZE_CHG 1
    #else
        #define SOMPERROR_ED_TYPE_SIZE_CHG SOMPError_SOMPERROR_ED_TYPE_SIZE_CHG
    #endif /* SOMPERROR_ED_TYPE_SIZE_CHG */
#endif /* SOMTGD_SOMPERROR_ED_TYPE_SIZE_CHG */
#ifndef SOMTGD_SOMPERROR_ED_UNSUPPORTED_TYPE
    #ifdef SOMPERROR_ED_UNSUPPORTED_TYPE
        #undef SOMPERROR_ED_UNSUPPORTED_TYPE
        #define SOMTGD_SOMPERROR_ED_UNSUPPORTED_TYPE 1
    #else
        #define SOMPERROR_ED_UNSUPPORTED_TYPE SOMPError_SOMPERROR_ED_UNSUPPORTED_TYPE
    #endif /* SOMPERROR_ED_UNSUPPORTED_TYPE */
#endif /* SOMTGD_SOMPERROR_ED_UNSUPPORTED_TYPE */
#ifndef SOMTGD_SOMPERROR_ED_CLASS_NOT_DEFINED
    #ifdef SOMPERROR_ED_CLASS_NOT_DEFINED
        #undef SOMPERROR_ED_CLASS_NOT_DEFINED
        #define SOMTGD_SOMPERROR_ED_CLASS_NOT_DEFINED 1
    #else
        #define SOMPERROR_ED_CLASS_NOT_DEFINED SOMPError_SOMPERROR_ED_CLASS_NOT_DEFINED
    #endif /* SOMPERROR_ED_CLASS_NOT_DEFINED */
#endif /* SOMTGD_SOMPERROR_ED_CLASS_NOT_DEFINED */
#ifndef SOMTGD_SOMPERROR_DUPLICATE_OBJECT_ID
    #ifdef SOMPERROR_DUPLICATE_OBJECT_ID
        #undef SOMPERROR_DUPLICATE_OBJECT_ID
        #define SOMTGD_SOMPERROR_DUPLICATE_OBJECT_ID 1
    #else
        #define SOMPERROR_DUPLICATE_OBJECT_ID SOMPError_SOMPERROR_DUPLICATE_OBJECT_ID
    #endif /* SOMPERROR_DUPLICATE_OBJECT_ID */
#endif /* SOMTGD_SOMPERROR_DUPLICATE_OBJECT_ID */
#ifndef SOMTGD_SOMPERROR_SOMDISPATCH_FAILED
    #ifdef SOMPERROR_SOMDISPATCH_FAILED
        #undef SOMPERROR_SOMDISPATCH_FAILED
        #define SOMTGD_SOMPERROR_SOMDISPATCH_FAILED 1
    #else
        #define SOMPERROR_SOMDISPATCH_FAILED SOMPError_SOMPERROR_SOMDISPATCH_FAILED
    #endif /* SOMPERROR_SOMDISPATCH_FAILED */
#endif /* SOMTGD_SOMPERROR_SOMDISPATCH_FAILED */
#ifndef SOMTGD_SOMPERROR_TEST_ERROR
    #ifdef SOMPERROR_TEST_ERROR
        #undef SOMPERROR_TEST_ERROR
        #define SOMTGD_SOMPERROR_TEST_ERROR 1
    #else
        #define SOMPERROR_TEST_ERROR SOMPError_SOMPERROR_TEST_ERROR
    #endif /* SOMPERROR_TEST_ERROR */
#endif /* SOMTGD_SOMPERROR_TEST_ERROR */
#ifndef SOMTGD_SOMPINFO_END_OF_ATTRIBUTES
    #ifdef SOMPINFO_END_OF_ATTRIBUTES
        #undef SOMPINFO_END_OF_ATTRIBUTES
        #define SOMTGD_SOMPINFO_END_OF_ATTRIBUTES 1
    #else
        #define SOMPINFO_END_OF_ATTRIBUTES SOMPError_SOMPINFO_END_OF_ATTRIBUTES
    #endif /* SOMPINFO_END_OF_ATTRIBUTES */
#endif /* SOMTGD_SOMPINFO_END_OF_ATTRIBUTES */
#ifndef SOMTGD_SOMPERROR_MAX
    #ifdef SOMPERROR_MAX
        #undef SOMPERROR_MAX
        #define SOMTGD_SOMPERROR_MAX 1
    #else
        #define SOMPERROR_MAX SOMPError_SOMPERROR_MAX
    #endif /* SOMPERROR_MAX */
#endif /* SOMTGD_SOMPERROR_MAX */
#endif /* SOM_DONT_USE_SHORT_NAMES */

/*
 * End of bindings for IDL types.
 */
#endif /* SOM_Module_somperrd_SOMPError_defined */
